// Auto-generated. Do not edit!

// (in-package fuse_models.srv)


"use strict";

const _serializer = _ros_msg_utils.Serialize;
const _arraySerializer = _serializer.Array;
const _deserializer = _ros_msg_utils.Deserialize;
const _arrayDeserializer = _deserializer.Array;
const _finder = _ros_msg_utils.Find;
const _getByteLength = _ros_msg_utils.getByteLength;
let fuse_msgs = _finder('fuse_msgs');

//-----------------------------------------------------------


//-----------------------------------------------------------

class SetGraphRequest {
  constructor(initObj={}) {
    if (initObj === null) {
      // initObj === null is a special case for deserialization where we don't initialize fields
      this.graph = null;
    }
    else {
      if (initObj.hasOwnProperty('graph')) {
        this.graph = initObj.graph
      }
      else {
        this.graph = new fuse_msgs.msg.SerializedGraph();
      }
    }
  }

  static serialize(obj, buffer, bufferOffset) {
    // Serializes a message object of type SetGraphRequest
    // Serialize message field [graph]
    bufferOffset = fuse_msgs.msg.SerializedGraph.serialize(obj.graph, buffer, bufferOffset);
    return bufferOffset;
  }

  static deserialize(buffer, bufferOffset=[0]) {
    //deserializes a message object of type SetGraphRequest
    let len;
    let data = new SetGraphRequest(null);
    // Deserialize message field [graph]
    data.graph = fuse_msgs.msg.SerializedGraph.deserialize(buffer, bufferOffset);
    return data;
  }

  static getMessageSize(object) {
    let length = 0;
    length += fuse_msgs.msg.SerializedGraph.getMessageSize(object.graph);
    return length;
  }

  static datatype() {
    // Returns string type for a service object
    return 'fuse_models/SetGraphRequest';
  }

  static md5sum() {
    //Returns md5sum for a message object
    return '3b84462dc7b28ea362c87b7e7b646ac6';
  }

  static messageDefinition() {
    // Returns full string definition for message
    return `
    fuse_msgs/SerializedGraph graph
    
    ================================================================================
    MSG: fuse_msgs/SerializedGraph
    std_msgs/Header header  # A timestamp associated with the graph
    string plugin_name      # The fully-qualified name of the plugin used to serialize/deserialize this graph
    uint8[] data            # The serialized graph as a raw data buffer
    
    ================================================================================
    MSG: std_msgs/Header
    # Standard metadata for higher-level stamped data types.
    # This is generally used to communicate timestamped data 
    # in a particular coordinate frame.
    # 
    # sequence ID: consecutively increasing ID 
    uint32 seq
    #Two-integer timestamp that is expressed as:
    # * stamp.sec: seconds (stamp_secs) since epoch (in Python the variable is called 'secs')
    # * stamp.nsec: nanoseconds since stamp_secs (in Python the variable is called 'nsecs')
    # time-handling sugar is provided by the client library
    time stamp
    #Frame this data is associated with
    string frame_id
    
    `;
  }

  static Resolve(msg) {
    // deep-construct a valid message object instance of whatever was passed in
    if (typeof msg !== 'object' || msg === null) {
      msg = {};
    }
    const resolved = new SetGraphRequest(null);
    if (msg.graph !== undefined) {
      resolved.graph = fuse_msgs.msg.SerializedGraph.Resolve(msg.graph)
    }
    else {
      resolved.graph = new fuse_msgs.msg.SerializedGraph()
    }

    return resolved;
    }
};

class SetGraphResponse {
  constructor(initObj={}) {
    if (initObj === null) {
      // initObj === null is a special case for deserialization where we don't initialize fields
      this.success = null;
      this.message = null;
    }
    else {
      if (initObj.hasOwnProperty('success')) {
        this.success = initObj.success
      }
      else {
        this.success = false;
      }
      if (initObj.hasOwnProperty('message')) {
        this.message = initObj.message
      }
      else {
        this.message = '';
      }
    }
  }

  static serialize(obj, buffer, bufferOffset) {
    // Serializes a message object of type SetGraphResponse
    // Serialize message field [success]
    bufferOffset = _serializer.bool(obj.success, buffer, bufferOffset);
    // Serialize message field [message]
    bufferOffset = _serializer.string(obj.message, buffer, bufferOffset);
    return bufferOffset;
  }

  static deserialize(buffer, bufferOffset=[0]) {
    //deserializes a message object of type SetGraphResponse
    let len;
    let data = new SetGraphResponse(null);
    // Deserialize message field [success]
    data.success = _deserializer.bool(buffer, bufferOffset);
    // Deserialize message field [message]
    data.message = _deserializer.string(buffer, bufferOffset);
    return data;
  }

  static getMessageSize(object) {
    let length = 0;
    length += _getByteLength(object.message);
    return length + 5;
  }

  static datatype() {
    // Returns string type for a service object
    return 'fuse_models/SetGraphResponse';
  }

  static md5sum() {
    //Returns md5sum for a message object
    return '937c9679a518e3a18d831e57125ea522';
  }

  static messageDefinition() {
    // Returns full string definition for message
    return `
    bool success
    string message
    
    
    `;
  }

  static Resolve(msg) {
    // deep-construct a valid message object instance of whatever was passed in
    if (typeof msg !== 'object' || msg === null) {
      msg = {};
    }
    const resolved = new SetGraphResponse(null);
    if (msg.success !== undefined) {
      resolved.success = msg.success;
    }
    else {
      resolved.success = false
    }

    if (msg.message !== undefined) {
      resolved.message = msg.message;
    }
    else {
      resolved.message = ''
    }

    return resolved;
    }
};

module.exports = {
  Request: SetGraphRequest,
  Response: SetGraphResponse,
  md5sum() { return '9beefc456013e891a6476576be7e5e1f'; },
  datatype() { return 'fuse_models/SetGraph'; }
};
